package pl.qumak;

import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;
import org.springframework.ws.client.core.support.WebServiceGatewaySupport;
import org.springframework.ws.soap.client.core.SoapActionCallback;
import pl.qumak.pull.PullService;
import pl.qumak.xsd.datex2.D2LogicalModel;

import javax.xml.bind.JAXBElement;

@Component
public class Client extends WebServiceGatewaySupport {

    @Value("${pull.url}")
    private String pullUrl;

    @Value("${push.url}")
    private String pushUrl;

    public D2LogicalModel pullRequest(D2LogicalModel d2LogicalModel) {
        System.out.println("Oczekiwanie na odpowiedź…");
        JAXBElement<D2LogicalModel> response;
        response = (JAXBElement<D2LogicalModel>) getWebServiceTemplate().marshalSendAndReceive(
                pullUrl,
                d2LogicalModel,
                new SoapActionCallback("http://datex2.eu/wsdl/clientPull/2_0/getDatex2Data"));
        return response.getValue();
    }

    public D2LogicalModel pushRequest(D2LogicalModel d2LogicalModel) {
        System.out.println("Oczekiwanie na odpowiedź…");
        JAXBElement<D2LogicalModel> response;
        response = (JAXBElement<D2LogicalModel>) getWebServiceTemplate().marshalSendAndReceive(
                pushUrl,
                d2LogicalModel,
                new SoapActionCallback("http://datex2.eu/wsdl/supplierPush/2_0/putDatex2Data"));
        return response.getValue();
    }
}
