package pl.qumak.push;

import pl.qumak.xsd.datex2.CountryEnum;
import pl.qumak.xsd.datex2.MultilingualString;
import pl.qumak.xsd.datex2.MultilingualStringValue;
import pl.qumak.xsd.datex2.ObjectFactory;
import java.util.List;

public class StringHelper {

    private final ObjectFactory factory;
    private final CountryEnum defaultLang;

    public StringHelper(ObjectFactory factory, CountryEnum defaultLang) {
        this.factory = factory;
        this.defaultLang = defaultLang;
    }

    public MultilingualString createFrom(String value) {
        return createFrom(value, defaultLang);
    }

    public MultilingualString createFrom(String value, CountryEnum lang) {
        final MultilingualString mls = factory.createMultilingualString();
        final MultilingualString.Values vals = factory.createMultilingualStringValues();
        final MultilingualStringValue val = factory.createMultilingualStringValue();
        val.setLang(lang.value());
        val.setValue(value);
        vals.getValue().add(val);
        mls.setValues(vals);
        return mls;
    }

    public static List<MultilingualStringValue> getFrom(MultilingualString value) {
        return value.getValues().getValue();
    }

    public static String getFirstFrom(MultilingualString value) {
        // not enough value
        return getFrom(value).get(0).getValue();
    }

}
